macro draw_button xpos,ypos,xsize,ysize,id,color
{
	mov eax,8
	mov ebx,xpos
	shl ebx,16
	add ebx,xsize
	mov ecx,ypos
	shl ecx,16
	add ecx,ysize
	mov edx,id
	mov esi,color
	int 0x40
}

macro proc arg1,arg2,arg3,arg4
{
	arg1:
	push ebp
	mov ebp,esp
	arg2 equ ebp+8
	arg3 equ ebp+12
	arg4 equ ebp+16

}
macro endp
{
	pop ebp
	ret 12
}

macro stdcall arg1,arg2,arg3,arg4
{
	push arg4
	push arg3
	push arg2
	call arg1
}


  use32
  org	 0x0

  db	 'MENUET01'
  dd	 0x01
  dd	 START
  dd	 _END
  dd	 I_END+0x1000
  dd	 I_END+0x1000
  dd	 0x0
  dd	 0x0

include "dockini.inc"
include "dockparser.inc"
include "icons.inc"
include "bmp.inc"
include "skincode.inc"

START:

	loaddockcfgfile
	mov eax,61
	mov ebx,1
	int 0x40
	xor ebx,ebx
	xor ecx,ecx
	mov cx,ax
	shr eax,16
	mov bx,ax
	sub ebx,420
	shr ebx,1
	mov [x_pos],ebx
	sub ecx,60
	mov [y_pos],ecx

	mov eax,48
	mov ebx,1
	mov ecx,1
	int 0x40
red:

    call draw_window

still:
  ;  mov eax,10

    mov eax,23	 ;wait 1 sec for event
    mov ebx,100
    int 0x40

    cmp  eax,1
    je	 red
    cmp  eax,2
    je	 key
    cmp  eax,3
    je	 button
    call draw_clock
    jmp  still



  key:
    mov eax,2
    int 0x40
    jmp  still

  button:
    mov eax,17
    int 0x40
    shr eax,8
    mov [btn_id],eax

    cmp [pid],0
    jna nokill
    mov eax,18
    mov ebx,18
    mov ecx,[pid]
    int 0x40

    nokill:
    mov eax,[btn_id]
    cmp  eax,8
    ja .nodock
    dec eax
    imul eax,120
    add eax,dockcfg
    add eax,60
    mov [fileinfo.subfunct],0x7
    mov [fileinfo.bytes],   0x0
    mov [fileinfo.buffer],  0x0
    mov [fileinfo.ptrpath], eax
    mov [fileinfo.params],  0x0
    mov eax,70
    mov ebx,fileinfo
   int	0x40
    mov [currentp],0
   jmp still
  .nodock:
    sub eax,10
    cmp eax,[currentp]
    jne .suite
	mov [currentp],0
	jmp still
    .suite:
    mov [currentp],eax



    mov [fileinfo.subfunct],0x7
    mov [fileinfo.params],  currentp
    mov [fileinfo.bytes],   0x0
    mov [fileinfo.buffer],  0x0
    mov [fileinfo.ptrpath], tmenu
    mov eax,70
    mov ebx,fileinfo
    int 0x40

    mov [pid],eax
    jmp still

  .exit:
	mov eax,-1
	int 0x40


draw_window:
  mov eax,12	;begin of redraw
  mov ebx,1
  int 0x40

  mov eax,0
  mov ebx,[x_pos]
  shl ebx,16
  mov bx,419
  mov ecx,[y_pos]
  shl ecx,16
  mov cx,54
  mov edx,0x01000000
  mov esi,0x01000000
  int 0x40


;======== boutons d'applications========
 draw_button	14,18,33,33,1,0x00224488
 draw_button	54,18,33,33,2,0x00224488
 draw_button	94,18,33,33,3,0x00224488
 draw_button   134,18,33,33,4,0x00224488

 draw_button   254,18,33,33,5,0x00224488
 draw_button   294,18,33,33,6,0x00224488
 draw_button   334,18,33,33,7,0x00224488
 draw_button   374,18,33,33,8,0x00224488
;=======================================

;======== boutons de menu =============
 draw_button	11,0,39,14,11,0x00224488
 draw_button	51,0,39,14,12,0x00224488
 draw_button	91,0,39,14,13,0x00224488
 draw_button   131,0,39,14,14,0x00224488

 draw_button   251,0,39,14,15,0x00224488
 draw_button   291,0,39,14,16,0x00224488
 draw_button   331,0,39,14,17,0x00224488
 draw_button   371,0,39,14,18,0x00224488
;======================================



;========= draw the skin =============
call load_skin_data
call draw_skin_data


;====================================

;====== draw icons ==============

    mov [cpt],0
    foricnx:
    mov ecx,[cpt]
    cmp ecx,4
    jnb nexticnx

      mov [icnx],ecx	    ; sauve le numro en cours
      imul ecx,120	    ; on calcule l'adresse du nom de
      add  ecx,dockcfg	    ; l'icone
      mov  ebx,[icnx]	    ; on calcule la position
      imul ebx,40	    ;
      add  ebx,14	    ;
	cmp byte [ecx],0
	jna .suite1

     ;stdcall drwicon,fname,xpos,ypos
      stdcall drwicon,ecx,ebx,19


	.suite1:
    inc [cpt]
    jmp foricnx
    nexticnx:

    mov ecx,4
    foricnx2:
    mov ecx,[cpt]
    cmp ecx,8
    jnb nexticnx2

      mov [icnx],ecx	    ; sauve le numro en cours
      imul ecx,120	    ; on calcule l'adresse du nom de
      add  ecx,dockcfg	    ; l'icone
      mov  ebx,[icnx]	    ; on calcule la position
      sub  ebx,4
      imul ebx,40	    ;
      add  ebx,253	    ;
	cmp byte [ecx],0
	jna .suite2

     ;stdcall drwicon,fname,xpos,ypos
      stdcall drwicon,ecx,ebx,19
	.suite2:
    inc [cpt]
    jmp foricnx2
    nexticnx2:



	mov  eax, 4		     ; draw normal text
	mov  ebx, 196 shl 16 + 35
	mov  ecx, [tcolor2]
	or   ecx,0x40000000
	mov  edi, [tcolor]
	mov  esi, 1		     ; 1 character
	mov  edx, heure
	int  0x40
	add  ebx, 25 shl 16	     ; 25 pixels to right
	int  0x40

call draw_clock
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   mov eax,12		;end of redraw
   mov ebx,2
   int 0x40
   ret


draw_clock:
	mov   eax, 3
	int   0x40		     ; get time in nBCD format (0x00hhmmss)
	push  eax		     ; push seconds
	shr   eax, 8
	push  eax		     ; push minutes
	shr   eax, 8
	push  eax		     ; push hours

	mov  eax, 47		     ; draw number
	mov  ebx, 1 shl 17 + 1 shl 8 ; 2 digits, hexadecimal
	mov  edx, 230 shl 16 + 35
	mov  esi, [tcolor2]
	or   esi,0x40000000
	mov  edi, [tcolor]
	pop  ecx		     ; pop hours
	int  0x40
	sub  edx, 25 shl 16	     ; 25 pixels to right
	pop  ecx		     ; pop minutes
	int  0x40
	sub  edx, 25 shl 16	     ; 25 pixels to right
	pop  ecx		     ; pop seconds
	int  0x40


ret


;;;;;;;;;;
;; Data ;;
;;;;;;;;;;
tcolor	dd 0x0
tcolor2 dd 0x0
heure db ':'
cpt1 dd 0x0
cpt2 dd 0x0
pid dd 0
currentp dd 0,0
cpt   dd 0x0
icnx  dd 0x0
x_pos dd 0x0
y_pos dd 0x0
btn_id dd 0x0
dockcfgfile   : db '/sys/dockini.dat',0
tmenu	      : db '/sys/@tmenu',0

skin:
	.file : db '/sys/dock.skn',0
	.left	: dd 0x0
	.right	: dd 0x0
	.bg	: dd 0x0
	.mbutton: dd 0x0
	.pbutton: dd 0x0
	.logo	: dd 0x0
	.clock	: dd 0x0


_END:
dockcfg rb 1200
skindata: rb 20000
imgdata: rb 20000
icon_buffer:rb 32*32*3+54
I_END:

